# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['KubernetesClusterArgs', 'KubernetesCluster']

@pulumi.input_type
class KubernetesClusterArgs:
    def __init__(__self__, *,
                 master: pulumi.Input['KubernetesClusterMasterArgs'],
                 network_id: pulumi.Input[str],
                 node_service_account_id: pulumi.Input[str],
                 service_account_id: pulumi.Input[str],
                 cluster_ipv4_range: Optional[pulumi.Input[str]] = None,
                 cluster_ipv6_range: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 kms_provider: Optional[pulumi.Input['KubernetesClusterKmsProviderArgs']] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_implementation: Optional[pulumi.Input['KubernetesClusterNetworkImplementationArgs']] = None,
                 network_policy_provider: Optional[pulumi.Input[str]] = None,
                 node_ipv4_cidr_mask_size: Optional[pulumi.Input[int]] = None,
                 release_channel: Optional[pulumi.Input[str]] = None,
                 service_ipv4_range: Optional[pulumi.Input[str]] = None,
                 service_ipv6_range: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a KubernetesCluster resource.
        :param pulumi.Input['KubernetesClusterMasterArgs'] master: Kubernetes master configuration options. The structure is documented below.
        :param pulumi.Input[str] network_id: The ID of the cluster network.
        :param pulumi.Input[str] node_service_account_id: Service account to be used by the worker nodes of the Kubernetes cluster
               to access Container Registry or to push node logs and metrics.
        :param pulumi.Input[str] service_account_id: Service account to be used for provisioning Compute Cloud and VPC resources
               for Kubernetes cluster. Selected service account should have `edit` role on the folder where the Kubernetes
               cluster will be located and on the folder where selected network resides.
        :param pulumi.Input[str] cluster_ipv4_range: CIDR block. IP range for allocating pod addresses.
               It should not overlap with any subnet in the network the Kubernetes cluster located in. Static routes will be
               set up for this CIDR blocks in node subnets.
        :param pulumi.Input[str] cluster_ipv6_range: Identical to cluster_ipv4_range but for IPv6 protocol.
        :param pulumi.Input[str] description: A description of the Kubernetes cluster.
        :param pulumi.Input[str] folder_id: The ID of the folder that the Kubernetes cluster belongs to.
               If it is not provided, the default provider folder is used.
        :param pulumi.Input['KubernetesClusterKmsProviderArgs'] kms_provider: cluster KMS provider parameters.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Kubernetes cluster.
        :param pulumi.Input[str] name: Name of a specific Kubernetes cluster.
        :param pulumi.Input['KubernetesClusterNetworkImplementationArgs'] network_implementation: (Optional) Network Implementation options. The structure is documented below.
               ---
        :param pulumi.Input[str] network_policy_provider: Network policy provider for the cluster. Possible values: `CALICO`.
        :param pulumi.Input[int] node_ipv4_cidr_mask_size: Size of the masks that are assigned to each node in the cluster. Effectively limits maximum number of pods for each node.
        :param pulumi.Input[str] release_channel: Cluster release channel.
        :param pulumi.Input[str] service_ipv4_range: CIDR block. IP range Kubernetes service Kubernetes cluster
               IP addresses will be allocated from. It should not overlap with any subnet in the network
               the Kubernetes cluster located in.
        :param pulumi.Input[str] service_ipv6_range: Identical to service_ipv4_range but for IPv6 protocol.
        """
        pulumi.set(__self__, "master", master)
        pulumi.set(__self__, "network_id", network_id)
        pulumi.set(__self__, "node_service_account_id", node_service_account_id)
        pulumi.set(__self__, "service_account_id", service_account_id)
        if cluster_ipv4_range is not None:
            pulumi.set(__self__, "cluster_ipv4_range", cluster_ipv4_range)
        if cluster_ipv6_range is not None:
            pulumi.set(__self__, "cluster_ipv6_range", cluster_ipv6_range)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if folder_id is not None:
            pulumi.set(__self__, "folder_id", folder_id)
        if kms_provider is not None:
            pulumi.set(__self__, "kms_provider", kms_provider)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_implementation is not None:
            pulumi.set(__self__, "network_implementation", network_implementation)
        if network_policy_provider is not None:
            pulumi.set(__self__, "network_policy_provider", network_policy_provider)
        if node_ipv4_cidr_mask_size is not None:
            pulumi.set(__self__, "node_ipv4_cidr_mask_size", node_ipv4_cidr_mask_size)
        if release_channel is not None:
            pulumi.set(__self__, "release_channel", release_channel)
        if service_ipv4_range is not None:
            pulumi.set(__self__, "service_ipv4_range", service_ipv4_range)
        if service_ipv6_range is not None:
            pulumi.set(__self__, "service_ipv6_range", service_ipv6_range)

    @property
    @pulumi.getter
    def master(self) -> pulumi.Input['KubernetesClusterMasterArgs']:
        """
        Kubernetes master configuration options. The structure is documented below.
        """
        return pulumi.get(self, "master")

    @master.setter
    def master(self, value: pulumi.Input['KubernetesClusterMasterArgs']):
        pulumi.set(self, "master", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Input[str]:
        """
        The ID of the cluster network.
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter(name="nodeServiceAccountId")
    def node_service_account_id(self) -> pulumi.Input[str]:
        """
        Service account to be used by the worker nodes of the Kubernetes cluster
        to access Container Registry or to push node logs and metrics.
        """
        return pulumi.get(self, "node_service_account_id")

    @node_service_account_id.setter
    def node_service_account_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "node_service_account_id", value)

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> pulumi.Input[str]:
        """
        Service account to be used for provisioning Compute Cloud and VPC resources
        for Kubernetes cluster. Selected service account should have `edit` role on the folder where the Kubernetes
        cluster will be located and on the folder where selected network resides.
        """
        return pulumi.get(self, "service_account_id")

    @service_account_id.setter
    def service_account_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "service_account_id", value)

    @property
    @pulumi.getter(name="clusterIpv4Range")
    def cluster_ipv4_range(self) -> Optional[pulumi.Input[str]]:
        """
        CIDR block. IP range for allocating pod addresses.
        It should not overlap with any subnet in the network the Kubernetes cluster located in. Static routes will be
        set up for this CIDR blocks in node subnets.
        """
        return pulumi.get(self, "cluster_ipv4_range")

    @cluster_ipv4_range.setter
    def cluster_ipv4_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_ipv4_range", value)

    @property
    @pulumi.getter(name="clusterIpv6Range")
    def cluster_ipv6_range(self) -> Optional[pulumi.Input[str]]:
        """
        Identical to cluster_ipv4_range but for IPv6 protocol.
        """
        return pulumi.get(self, "cluster_ipv6_range")

    @cluster_ipv6_range.setter
    def cluster_ipv6_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_ipv6_range", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        A description of the Kubernetes cluster.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the folder that the Kubernetes cluster belongs to.
        If it is not provided, the default provider folder is used.
        """
        return pulumi.get(self, "folder_id")

    @folder_id.setter
    def folder_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder_id", value)

    @property
    @pulumi.getter(name="kmsProvider")
    def kms_provider(self) -> Optional[pulumi.Input['KubernetesClusterKmsProviderArgs']]:
        """
        cluster KMS provider parameters.
        """
        return pulumi.get(self, "kms_provider")

    @kms_provider.setter
    def kms_provider(self, value: Optional[pulumi.Input['KubernetesClusterKmsProviderArgs']]):
        pulumi.set(self, "kms_provider", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value label pairs to assign to the Kubernetes cluster.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of a specific Kubernetes cluster.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkImplementation")
    def network_implementation(self) -> Optional[pulumi.Input['KubernetesClusterNetworkImplementationArgs']]:
        """
        (Optional) Network Implementation options. The structure is documented below.
        ---
        """
        return pulumi.get(self, "network_implementation")

    @network_implementation.setter
    def network_implementation(self, value: Optional[pulumi.Input['KubernetesClusterNetworkImplementationArgs']]):
        pulumi.set(self, "network_implementation", value)

    @property
    @pulumi.getter(name="networkPolicyProvider")
    def network_policy_provider(self) -> Optional[pulumi.Input[str]]:
        """
        Network policy provider for the cluster. Possible values: `CALICO`.
        """
        return pulumi.get(self, "network_policy_provider")

    @network_policy_provider.setter
    def network_policy_provider(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_policy_provider", value)

    @property
    @pulumi.getter(name="nodeIpv4CidrMaskSize")
    def node_ipv4_cidr_mask_size(self) -> Optional[pulumi.Input[int]]:
        """
        Size of the masks that are assigned to each node in the cluster. Effectively limits maximum number of pods for each node.
        """
        return pulumi.get(self, "node_ipv4_cidr_mask_size")

    @node_ipv4_cidr_mask_size.setter
    def node_ipv4_cidr_mask_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "node_ipv4_cidr_mask_size", value)

    @property
    @pulumi.getter(name="releaseChannel")
    def release_channel(self) -> Optional[pulumi.Input[str]]:
        """
        Cluster release channel.
        """
        return pulumi.get(self, "release_channel")

    @release_channel.setter
    def release_channel(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "release_channel", value)

    @property
    @pulumi.getter(name="serviceIpv4Range")
    def service_ipv4_range(self) -> Optional[pulumi.Input[str]]:
        """
        CIDR block. IP range Kubernetes service Kubernetes cluster
        IP addresses will be allocated from. It should not overlap with any subnet in the network
        the Kubernetes cluster located in.
        """
        return pulumi.get(self, "service_ipv4_range")

    @service_ipv4_range.setter
    def service_ipv4_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_ipv4_range", value)

    @property
    @pulumi.getter(name="serviceIpv6Range")
    def service_ipv6_range(self) -> Optional[pulumi.Input[str]]:
        """
        Identical to service_ipv4_range but for IPv6 protocol.
        """
        return pulumi.get(self, "service_ipv6_range")

    @service_ipv6_range.setter
    def service_ipv6_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_ipv6_range", value)


@pulumi.input_type
class _KubernetesClusterState:
    def __init__(__self__, *,
                 cluster_ipv4_range: Optional[pulumi.Input[str]] = None,
                 cluster_ipv6_range: Optional[pulumi.Input[str]] = None,
                 created_at: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 health: Optional[pulumi.Input[str]] = None,
                 kms_provider: Optional[pulumi.Input['KubernetesClusterKmsProviderArgs']] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 log_group_id: Optional[pulumi.Input[str]] = None,
                 master: Optional[pulumi.Input['KubernetesClusterMasterArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 network_implementation: Optional[pulumi.Input['KubernetesClusterNetworkImplementationArgs']] = None,
                 network_policy_provider: Optional[pulumi.Input[str]] = None,
                 node_ipv4_cidr_mask_size: Optional[pulumi.Input[int]] = None,
                 node_service_account_id: Optional[pulumi.Input[str]] = None,
                 release_channel: Optional[pulumi.Input[str]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 service_ipv4_range: Optional[pulumi.Input[str]] = None,
                 service_ipv6_range: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering KubernetesCluster resources.
        :param pulumi.Input[str] cluster_ipv4_range: CIDR block. IP range for allocating pod addresses.
               It should not overlap with any subnet in the network the Kubernetes cluster located in. Static routes will be
               set up for this CIDR blocks in node subnets.
        :param pulumi.Input[str] cluster_ipv6_range: Identical to cluster_ipv4_range but for IPv6 protocol.
        :param pulumi.Input[str] created_at: (Computed) The Kubernetes cluster creation timestamp.
        :param pulumi.Input[str] description: A description of the Kubernetes cluster.
        :param pulumi.Input[str] folder_id: The ID of the folder that the Kubernetes cluster belongs to.
               If it is not provided, the default provider folder is used.
        :param pulumi.Input[str] health: (Computed) Health of the Kubernetes cluster.
        :param pulumi.Input['KubernetesClusterKmsProviderArgs'] kms_provider: cluster KMS provider parameters.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Kubernetes cluster.
        :param pulumi.Input[str] log_group_id: Log group where cluster stores cluster system logs, like audit, events, or controlplane logs.
        :param pulumi.Input['KubernetesClusterMasterArgs'] master: Kubernetes master configuration options. The structure is documented below.
        :param pulumi.Input[str] name: Name of a specific Kubernetes cluster.
        :param pulumi.Input[str] network_id: The ID of the cluster network.
        :param pulumi.Input['KubernetesClusterNetworkImplementationArgs'] network_implementation: (Optional) Network Implementation options. The structure is documented below.
               ---
        :param pulumi.Input[str] network_policy_provider: Network policy provider for the cluster. Possible values: `CALICO`.
        :param pulumi.Input[int] node_ipv4_cidr_mask_size: Size of the masks that are assigned to each node in the cluster. Effectively limits maximum number of pods for each node.
        :param pulumi.Input[str] node_service_account_id: Service account to be used by the worker nodes of the Kubernetes cluster
               to access Container Registry or to push node logs and metrics.
        :param pulumi.Input[str] release_channel: Cluster release channel.
        :param pulumi.Input[str] service_account_id: Service account to be used for provisioning Compute Cloud and VPC resources
               for Kubernetes cluster. Selected service account should have `edit` role on the folder where the Kubernetes
               cluster will be located and on the folder where selected network resides.
        :param pulumi.Input[str] service_ipv4_range: CIDR block. IP range Kubernetes service Kubernetes cluster
               IP addresses will be allocated from. It should not overlap with any subnet in the network
               the Kubernetes cluster located in.
        :param pulumi.Input[str] service_ipv6_range: Identical to service_ipv4_range but for IPv6 protocol.
        :param pulumi.Input[str] status: (Computed)Status of the Kubernetes cluster.
        """
        if cluster_ipv4_range is not None:
            pulumi.set(__self__, "cluster_ipv4_range", cluster_ipv4_range)
        if cluster_ipv6_range is not None:
            pulumi.set(__self__, "cluster_ipv6_range", cluster_ipv6_range)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if folder_id is not None:
            pulumi.set(__self__, "folder_id", folder_id)
        if health is not None:
            pulumi.set(__self__, "health", health)
        if kms_provider is not None:
            pulumi.set(__self__, "kms_provider", kms_provider)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if log_group_id is not None:
            pulumi.set(__self__, "log_group_id", log_group_id)
        if master is not None:
            pulumi.set(__self__, "master", master)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_id is not None:
            pulumi.set(__self__, "network_id", network_id)
        if network_implementation is not None:
            pulumi.set(__self__, "network_implementation", network_implementation)
        if network_policy_provider is not None:
            pulumi.set(__self__, "network_policy_provider", network_policy_provider)
        if node_ipv4_cidr_mask_size is not None:
            pulumi.set(__self__, "node_ipv4_cidr_mask_size", node_ipv4_cidr_mask_size)
        if node_service_account_id is not None:
            pulumi.set(__self__, "node_service_account_id", node_service_account_id)
        if release_channel is not None:
            pulumi.set(__self__, "release_channel", release_channel)
        if service_account_id is not None:
            pulumi.set(__self__, "service_account_id", service_account_id)
        if service_ipv4_range is not None:
            pulumi.set(__self__, "service_ipv4_range", service_ipv4_range)
        if service_ipv6_range is not None:
            pulumi.set(__self__, "service_ipv6_range", service_ipv6_range)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="clusterIpv4Range")
    def cluster_ipv4_range(self) -> Optional[pulumi.Input[str]]:
        """
        CIDR block. IP range for allocating pod addresses.
        It should not overlap with any subnet in the network the Kubernetes cluster located in. Static routes will be
        set up for this CIDR blocks in node subnets.
        """
        return pulumi.get(self, "cluster_ipv4_range")

    @cluster_ipv4_range.setter
    def cluster_ipv4_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_ipv4_range", value)

    @property
    @pulumi.getter(name="clusterIpv6Range")
    def cluster_ipv6_range(self) -> Optional[pulumi.Input[str]]:
        """
        Identical to cluster_ipv4_range but for IPv6 protocol.
        """
        return pulumi.get(self, "cluster_ipv6_range")

    @cluster_ipv6_range.setter
    def cluster_ipv6_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_ipv6_range", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed) The Kubernetes cluster creation timestamp.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        A description of the Kubernetes cluster.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the folder that the Kubernetes cluster belongs to.
        If it is not provided, the default provider folder is used.
        """
        return pulumi.get(self, "folder_id")

    @folder_id.setter
    def folder_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder_id", value)

    @property
    @pulumi.getter
    def health(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed) Health of the Kubernetes cluster.
        """
        return pulumi.get(self, "health")

    @health.setter
    def health(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "health", value)

    @property
    @pulumi.getter(name="kmsProvider")
    def kms_provider(self) -> Optional[pulumi.Input['KubernetesClusterKmsProviderArgs']]:
        """
        cluster KMS provider parameters.
        """
        return pulumi.get(self, "kms_provider")

    @kms_provider.setter
    def kms_provider(self, value: Optional[pulumi.Input['KubernetesClusterKmsProviderArgs']]):
        pulumi.set(self, "kms_provider", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value label pairs to assign to the Kubernetes cluster.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter(name="logGroupId")
    def log_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        Log group where cluster stores cluster system logs, like audit, events, or controlplane logs.
        """
        return pulumi.get(self, "log_group_id")

    @log_group_id.setter
    def log_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "log_group_id", value)

    @property
    @pulumi.getter
    def master(self) -> Optional[pulumi.Input['KubernetesClusterMasterArgs']]:
        """
        Kubernetes master configuration options. The structure is documented below.
        """
        return pulumi.get(self, "master")

    @master.setter
    def master(self, value: Optional[pulumi.Input['KubernetesClusterMasterArgs']]):
        pulumi.set(self, "master", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of a specific Kubernetes cluster.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the cluster network.
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter(name="networkImplementation")
    def network_implementation(self) -> Optional[pulumi.Input['KubernetesClusterNetworkImplementationArgs']]:
        """
        (Optional) Network Implementation options. The structure is documented below.
        ---
        """
        return pulumi.get(self, "network_implementation")

    @network_implementation.setter
    def network_implementation(self, value: Optional[pulumi.Input['KubernetesClusterNetworkImplementationArgs']]):
        pulumi.set(self, "network_implementation", value)

    @property
    @pulumi.getter(name="networkPolicyProvider")
    def network_policy_provider(self) -> Optional[pulumi.Input[str]]:
        """
        Network policy provider for the cluster. Possible values: `CALICO`.
        """
        return pulumi.get(self, "network_policy_provider")

    @network_policy_provider.setter
    def network_policy_provider(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_policy_provider", value)

    @property
    @pulumi.getter(name="nodeIpv4CidrMaskSize")
    def node_ipv4_cidr_mask_size(self) -> Optional[pulumi.Input[int]]:
        """
        Size of the masks that are assigned to each node in the cluster. Effectively limits maximum number of pods for each node.
        """
        return pulumi.get(self, "node_ipv4_cidr_mask_size")

    @node_ipv4_cidr_mask_size.setter
    def node_ipv4_cidr_mask_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "node_ipv4_cidr_mask_size", value)

    @property
    @pulumi.getter(name="nodeServiceAccountId")
    def node_service_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        Service account to be used by the worker nodes of the Kubernetes cluster
        to access Container Registry or to push node logs and metrics.
        """
        return pulumi.get(self, "node_service_account_id")

    @node_service_account_id.setter
    def node_service_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "node_service_account_id", value)

    @property
    @pulumi.getter(name="releaseChannel")
    def release_channel(self) -> Optional[pulumi.Input[str]]:
        """
        Cluster release channel.
        """
        return pulumi.get(self, "release_channel")

    @release_channel.setter
    def release_channel(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "release_channel", value)

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        Service account to be used for provisioning Compute Cloud and VPC resources
        for Kubernetes cluster. Selected service account should have `edit` role on the folder where the Kubernetes
        cluster will be located and on the folder where selected network resides.
        """
        return pulumi.get(self, "service_account_id")

    @service_account_id.setter
    def service_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_account_id", value)

    @property
    @pulumi.getter(name="serviceIpv4Range")
    def service_ipv4_range(self) -> Optional[pulumi.Input[str]]:
        """
        CIDR block. IP range Kubernetes service Kubernetes cluster
        IP addresses will be allocated from. It should not overlap with any subnet in the network
        the Kubernetes cluster located in.
        """
        return pulumi.get(self, "service_ipv4_range")

    @service_ipv4_range.setter
    def service_ipv4_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_ipv4_range", value)

    @property
    @pulumi.getter(name="serviceIpv6Range")
    def service_ipv6_range(self) -> Optional[pulumi.Input[str]]:
        """
        Identical to service_ipv4_range but for IPv6 protocol.
        """
        return pulumi.get(self, "service_ipv6_range")

    @service_ipv6_range.setter
    def service_ipv6_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_ipv6_range", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed)Status of the Kubernetes cluster.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)


class KubernetesCluster(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_ipv4_range: Optional[pulumi.Input[str]] = None,
                 cluster_ipv6_range: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 kms_provider: Optional[pulumi.Input[pulumi.InputType['KubernetesClusterKmsProviderArgs']]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 master: Optional[pulumi.Input[pulumi.InputType['KubernetesClusterMasterArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 network_implementation: Optional[pulumi.Input[pulumi.InputType['KubernetesClusterNetworkImplementationArgs']]] = None,
                 network_policy_provider: Optional[pulumi.Input[str]] = None,
                 node_ipv4_cidr_mask_size: Optional[pulumi.Input[int]] = None,
                 node_service_account_id: Optional[pulumi.Input[str]] = None,
                 release_channel: Optional[pulumi.Input[str]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 service_ipv4_range: Optional[pulumi.Input[str]] = None,
                 service_ipv6_range: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Creates a Yandex Kubernetes Cluster.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_yandex as yandex

        zonal_cluster_resource_name = yandex.KubernetesCluster("zonalClusterResourceName",
            description="description",
            kms_provider=yandex.KubernetesClusterKmsProviderArgs(
                key_id=yandex_kms_symmetric_key["kms_key_resource_name"]["id"],
            ),
            labels={
                "my_key": "my_value",
                "my_other_key": "my_other_value",
            },
            master=yandex.KubernetesClusterMasterArgs(
                maintenance_policy={
                    "autoUpgrade": True,
                    "maintenance_window": [{
                        "duration": "3h",
                        "startTime": "15:00",
                    }],
                },
                public_ip=True,
                security_group_ids=[yandex_vpc_security_group["security_group_name"]["id"]],
                version="1.17",
                zonal=yandex.KubernetesClusterMasterZonalArgs(
                    subnet_id=yandex_vpc_subnet["subnet_resource_name"]["id"],
                    zone=yandex_vpc_subnet["subnet_resource_name"]["zone"],
                ),
            ),
            network_id=yandex_vpc_network["network_resource_name"]["id"],
            network_policy_provider="CALICO",
            node_service_account_id=yandex_iam_service_account["node_service_account_resource_name"]["id"],
            release_channel="RAPID",
            service_account_id=yandex_iam_service_account["service_account_resource_name"]["id"])
        ```

        ```python
        import pulumi
        import pulumi_yandex as yandex

        regional_cluster_resource_name = yandex.KubernetesCluster("regionalClusterResourceName",
            description="description",
            labels={
                "my_key": "my_value",
                "my_other_key": "my_other_value",
            },
            master=yandex.KubernetesClusterMasterArgs(
                maintenance_policy={
                    "autoUpgrade": True,
                    "maintenance_window": [
                        {
                            "day": "monday",
                            "duration": "3h",
                            "startTime": "15:00",
                        },
                        {
                            "day": "friday",
                            "duration": "4h30m",
                            "startTime": "10:00",
                        },
                    ],
                },
                public_ip=True,
                regional=yandex.KubernetesClusterMasterRegionalArgs(
                    location=[
                        {
                            "subnetId": yandex_vpc_subnet["subnet_a_resource_name"]["id"],
                            "zone": yandex_vpc_subnet["subnet_a_resource_name"]["zone"],
                        },
                        {
                            "subnetId": yandex_vpc_subnet["subnet_b_resource_name"]["id"],
                            "zone": yandex_vpc_subnet["subnet_b_resource_name"]["zone"],
                        },
                        {
                            "subnetId": yandex_vpc_subnet["subnet_c_resource_name"]["id"],
                            "zone": yandex_vpc_subnet["subnet_c_resource_name"]["zone"],
                        },
                    ],
                    region="ru-central1",
                ),
                version="1.14",
            ),
            network_id=yandex_vpc_network["network_resource_name"]["id"],
            node_service_account_id=yandex_iam_service_account["node_service_account_resource_name"]["id"],
            release_channel="STABLE",
            service_account_id=yandex_iam_service_account["service_account_resource_name"]["id"])
        ```

        ## Import

        A Managed Kubernetes cluster can be imported using the `id` of the resource, e.g.

        ```sh
         $ pulumi import yandex:index/kubernetesCluster:KubernetesCluster default cluster_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_ipv4_range: CIDR block. IP range for allocating pod addresses.
               It should not overlap with any subnet in the network the Kubernetes cluster located in. Static routes will be
               set up for this CIDR blocks in node subnets.
        :param pulumi.Input[str] cluster_ipv6_range: Identical to cluster_ipv4_range but for IPv6 protocol.
        :param pulumi.Input[str] description: A description of the Kubernetes cluster.
        :param pulumi.Input[str] folder_id: The ID of the folder that the Kubernetes cluster belongs to.
               If it is not provided, the default provider folder is used.
        :param pulumi.Input[pulumi.InputType['KubernetesClusterKmsProviderArgs']] kms_provider: cluster KMS provider parameters.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Kubernetes cluster.
        :param pulumi.Input[pulumi.InputType['KubernetesClusterMasterArgs']] master: Kubernetes master configuration options. The structure is documented below.
        :param pulumi.Input[str] name: Name of a specific Kubernetes cluster.
        :param pulumi.Input[str] network_id: The ID of the cluster network.
        :param pulumi.Input[pulumi.InputType['KubernetesClusterNetworkImplementationArgs']] network_implementation: (Optional) Network Implementation options. The structure is documented below.
               ---
        :param pulumi.Input[str] network_policy_provider: Network policy provider for the cluster. Possible values: `CALICO`.
        :param pulumi.Input[int] node_ipv4_cidr_mask_size: Size of the masks that are assigned to each node in the cluster. Effectively limits maximum number of pods for each node.
        :param pulumi.Input[str] node_service_account_id: Service account to be used by the worker nodes of the Kubernetes cluster
               to access Container Registry or to push node logs and metrics.
        :param pulumi.Input[str] release_channel: Cluster release channel.
        :param pulumi.Input[str] service_account_id: Service account to be used for provisioning Compute Cloud and VPC resources
               for Kubernetes cluster. Selected service account should have `edit` role on the folder where the Kubernetes
               cluster will be located and on the folder where selected network resides.
        :param pulumi.Input[str] service_ipv4_range: CIDR block. IP range Kubernetes service Kubernetes cluster
               IP addresses will be allocated from. It should not overlap with any subnet in the network
               the Kubernetes cluster located in.
        :param pulumi.Input[str] service_ipv6_range: Identical to service_ipv4_range but for IPv6 protocol.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: KubernetesClusterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Creates a Yandex Kubernetes Cluster.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_yandex as yandex

        zonal_cluster_resource_name = yandex.KubernetesCluster("zonalClusterResourceName",
            description="description",
            kms_provider=yandex.KubernetesClusterKmsProviderArgs(
                key_id=yandex_kms_symmetric_key["kms_key_resource_name"]["id"],
            ),
            labels={
                "my_key": "my_value",
                "my_other_key": "my_other_value",
            },
            master=yandex.KubernetesClusterMasterArgs(
                maintenance_policy={
                    "autoUpgrade": True,
                    "maintenance_window": [{
                        "duration": "3h",
                        "startTime": "15:00",
                    }],
                },
                public_ip=True,
                security_group_ids=[yandex_vpc_security_group["security_group_name"]["id"]],
                version="1.17",
                zonal=yandex.KubernetesClusterMasterZonalArgs(
                    subnet_id=yandex_vpc_subnet["subnet_resource_name"]["id"],
                    zone=yandex_vpc_subnet["subnet_resource_name"]["zone"],
                ),
            ),
            network_id=yandex_vpc_network["network_resource_name"]["id"],
            network_policy_provider="CALICO",
            node_service_account_id=yandex_iam_service_account["node_service_account_resource_name"]["id"],
            release_channel="RAPID",
            service_account_id=yandex_iam_service_account["service_account_resource_name"]["id"])
        ```

        ```python
        import pulumi
        import pulumi_yandex as yandex

        regional_cluster_resource_name = yandex.KubernetesCluster("regionalClusterResourceName",
            description="description",
            labels={
                "my_key": "my_value",
                "my_other_key": "my_other_value",
            },
            master=yandex.KubernetesClusterMasterArgs(
                maintenance_policy={
                    "autoUpgrade": True,
                    "maintenance_window": [
                        {
                            "day": "monday",
                            "duration": "3h",
                            "startTime": "15:00",
                        },
                        {
                            "day": "friday",
                            "duration": "4h30m",
                            "startTime": "10:00",
                        },
                    ],
                },
                public_ip=True,
                regional=yandex.KubernetesClusterMasterRegionalArgs(
                    location=[
                        {
                            "subnetId": yandex_vpc_subnet["subnet_a_resource_name"]["id"],
                            "zone": yandex_vpc_subnet["subnet_a_resource_name"]["zone"],
                        },
                        {
                            "subnetId": yandex_vpc_subnet["subnet_b_resource_name"]["id"],
                            "zone": yandex_vpc_subnet["subnet_b_resource_name"]["zone"],
                        },
                        {
                            "subnetId": yandex_vpc_subnet["subnet_c_resource_name"]["id"],
                            "zone": yandex_vpc_subnet["subnet_c_resource_name"]["zone"],
                        },
                    ],
                    region="ru-central1",
                ),
                version="1.14",
            ),
            network_id=yandex_vpc_network["network_resource_name"]["id"],
            node_service_account_id=yandex_iam_service_account["node_service_account_resource_name"]["id"],
            release_channel="STABLE",
            service_account_id=yandex_iam_service_account["service_account_resource_name"]["id"])
        ```

        ## Import

        A Managed Kubernetes cluster can be imported using the `id` of the resource, e.g.

        ```sh
         $ pulumi import yandex:index/kubernetesCluster:KubernetesCluster default cluster_id
        ```

        :param str resource_name: The name of the resource.
        :param KubernetesClusterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(KubernetesClusterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_ipv4_range: Optional[pulumi.Input[str]] = None,
                 cluster_ipv6_range: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 kms_provider: Optional[pulumi.Input[pulumi.InputType['KubernetesClusterKmsProviderArgs']]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 master: Optional[pulumi.Input[pulumi.InputType['KubernetesClusterMasterArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 network_implementation: Optional[pulumi.Input[pulumi.InputType['KubernetesClusterNetworkImplementationArgs']]] = None,
                 network_policy_provider: Optional[pulumi.Input[str]] = None,
                 node_ipv4_cidr_mask_size: Optional[pulumi.Input[int]] = None,
                 node_service_account_id: Optional[pulumi.Input[str]] = None,
                 release_channel: Optional[pulumi.Input[str]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 service_ipv4_range: Optional[pulumi.Input[str]] = None,
                 service_ipv6_range: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = KubernetesClusterArgs.__new__(KubernetesClusterArgs)

            __props__.__dict__["cluster_ipv4_range"] = cluster_ipv4_range
            __props__.__dict__["cluster_ipv6_range"] = cluster_ipv6_range
            __props__.__dict__["description"] = description
            __props__.__dict__["folder_id"] = folder_id
            __props__.__dict__["kms_provider"] = kms_provider
            __props__.__dict__["labels"] = labels
            if master is None and not opts.urn:
                raise TypeError("Missing required property 'master'")
            __props__.__dict__["master"] = master
            __props__.__dict__["name"] = name
            if network_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_id'")
            __props__.__dict__["network_id"] = network_id
            __props__.__dict__["network_implementation"] = network_implementation
            __props__.__dict__["network_policy_provider"] = network_policy_provider
            __props__.__dict__["node_ipv4_cidr_mask_size"] = node_ipv4_cidr_mask_size
            if node_service_account_id is None and not opts.urn:
                raise TypeError("Missing required property 'node_service_account_id'")
            __props__.__dict__["node_service_account_id"] = node_service_account_id
            __props__.__dict__["release_channel"] = release_channel
            if service_account_id is None and not opts.urn:
                raise TypeError("Missing required property 'service_account_id'")
            __props__.__dict__["service_account_id"] = service_account_id
            __props__.__dict__["service_ipv4_range"] = service_ipv4_range
            __props__.__dict__["service_ipv6_range"] = service_ipv6_range
            __props__.__dict__["created_at"] = None
            __props__.__dict__["health"] = None
            __props__.__dict__["log_group_id"] = None
            __props__.__dict__["status"] = None
        super(KubernetesCluster, __self__).__init__(
            'yandex:index/kubernetesCluster:KubernetesCluster',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cluster_ipv4_range: Optional[pulumi.Input[str]] = None,
            cluster_ipv6_range: Optional[pulumi.Input[str]] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            folder_id: Optional[pulumi.Input[str]] = None,
            health: Optional[pulumi.Input[str]] = None,
            kms_provider: Optional[pulumi.Input[pulumi.InputType['KubernetesClusterKmsProviderArgs']]] = None,
            labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            log_group_id: Optional[pulumi.Input[str]] = None,
            master: Optional[pulumi.Input[pulumi.InputType['KubernetesClusterMasterArgs']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            network_id: Optional[pulumi.Input[str]] = None,
            network_implementation: Optional[pulumi.Input[pulumi.InputType['KubernetesClusterNetworkImplementationArgs']]] = None,
            network_policy_provider: Optional[pulumi.Input[str]] = None,
            node_ipv4_cidr_mask_size: Optional[pulumi.Input[int]] = None,
            node_service_account_id: Optional[pulumi.Input[str]] = None,
            release_channel: Optional[pulumi.Input[str]] = None,
            service_account_id: Optional[pulumi.Input[str]] = None,
            service_ipv4_range: Optional[pulumi.Input[str]] = None,
            service_ipv6_range: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None) -> 'KubernetesCluster':
        """
        Get an existing KubernetesCluster resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_ipv4_range: CIDR block. IP range for allocating pod addresses.
               It should not overlap with any subnet in the network the Kubernetes cluster located in. Static routes will be
               set up for this CIDR blocks in node subnets.
        :param pulumi.Input[str] cluster_ipv6_range: Identical to cluster_ipv4_range but for IPv6 protocol.
        :param pulumi.Input[str] created_at: (Computed) The Kubernetes cluster creation timestamp.
        :param pulumi.Input[str] description: A description of the Kubernetes cluster.
        :param pulumi.Input[str] folder_id: The ID of the folder that the Kubernetes cluster belongs to.
               If it is not provided, the default provider folder is used.
        :param pulumi.Input[str] health: (Computed) Health of the Kubernetes cluster.
        :param pulumi.Input[pulumi.InputType['KubernetesClusterKmsProviderArgs']] kms_provider: cluster KMS provider parameters.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Kubernetes cluster.
        :param pulumi.Input[str] log_group_id: Log group where cluster stores cluster system logs, like audit, events, or controlplane logs.
        :param pulumi.Input[pulumi.InputType['KubernetesClusterMasterArgs']] master: Kubernetes master configuration options. The structure is documented below.
        :param pulumi.Input[str] name: Name of a specific Kubernetes cluster.
        :param pulumi.Input[str] network_id: The ID of the cluster network.
        :param pulumi.Input[pulumi.InputType['KubernetesClusterNetworkImplementationArgs']] network_implementation: (Optional) Network Implementation options. The structure is documented below.
               ---
        :param pulumi.Input[str] network_policy_provider: Network policy provider for the cluster. Possible values: `CALICO`.
        :param pulumi.Input[int] node_ipv4_cidr_mask_size: Size of the masks that are assigned to each node in the cluster. Effectively limits maximum number of pods for each node.
        :param pulumi.Input[str] node_service_account_id: Service account to be used by the worker nodes of the Kubernetes cluster
               to access Container Registry or to push node logs and metrics.
        :param pulumi.Input[str] release_channel: Cluster release channel.
        :param pulumi.Input[str] service_account_id: Service account to be used for provisioning Compute Cloud and VPC resources
               for Kubernetes cluster. Selected service account should have `edit` role on the folder where the Kubernetes
               cluster will be located and on the folder where selected network resides.
        :param pulumi.Input[str] service_ipv4_range: CIDR block. IP range Kubernetes service Kubernetes cluster
               IP addresses will be allocated from. It should not overlap with any subnet in the network
               the Kubernetes cluster located in.
        :param pulumi.Input[str] service_ipv6_range: Identical to service_ipv4_range but for IPv6 protocol.
        :param pulumi.Input[str] status: (Computed)Status of the Kubernetes cluster.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _KubernetesClusterState.__new__(_KubernetesClusterState)

        __props__.__dict__["cluster_ipv4_range"] = cluster_ipv4_range
        __props__.__dict__["cluster_ipv6_range"] = cluster_ipv6_range
        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["description"] = description
        __props__.__dict__["folder_id"] = folder_id
        __props__.__dict__["health"] = health
        __props__.__dict__["kms_provider"] = kms_provider
        __props__.__dict__["labels"] = labels
        __props__.__dict__["log_group_id"] = log_group_id
        __props__.__dict__["master"] = master
        __props__.__dict__["name"] = name
        __props__.__dict__["network_id"] = network_id
        __props__.__dict__["network_implementation"] = network_implementation
        __props__.__dict__["network_policy_provider"] = network_policy_provider
        __props__.__dict__["node_ipv4_cidr_mask_size"] = node_ipv4_cidr_mask_size
        __props__.__dict__["node_service_account_id"] = node_service_account_id
        __props__.__dict__["release_channel"] = release_channel
        __props__.__dict__["service_account_id"] = service_account_id
        __props__.__dict__["service_ipv4_range"] = service_ipv4_range
        __props__.__dict__["service_ipv6_range"] = service_ipv6_range
        __props__.__dict__["status"] = status
        return KubernetesCluster(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="clusterIpv4Range")
    def cluster_ipv4_range(self) -> pulumi.Output[str]:
        """
        CIDR block. IP range for allocating pod addresses.
        It should not overlap with any subnet in the network the Kubernetes cluster located in. Static routes will be
        set up for this CIDR blocks in node subnets.
        """
        return pulumi.get(self, "cluster_ipv4_range")

    @property
    @pulumi.getter(name="clusterIpv6Range")
    def cluster_ipv6_range(self) -> pulumi.Output[str]:
        """
        Identical to cluster_ipv4_range but for IPv6 protocol.
        """
        return pulumi.get(self, "cluster_ipv6_range")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        (Computed) The Kubernetes cluster creation timestamp.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        A description of the Kubernetes cluster.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> pulumi.Output[str]:
        """
        The ID of the folder that the Kubernetes cluster belongs to.
        If it is not provided, the default provider folder is used.
        """
        return pulumi.get(self, "folder_id")

    @property
    @pulumi.getter
    def health(self) -> pulumi.Output[str]:
        """
        (Computed) Health of the Kubernetes cluster.
        """
        return pulumi.get(self, "health")

    @property
    @pulumi.getter(name="kmsProvider")
    def kms_provider(self) -> pulumi.Output[Optional['outputs.KubernetesClusterKmsProvider']]:
        """
        cluster KMS provider parameters.
        """
        return pulumi.get(self, "kms_provider")

    @property
    @pulumi.getter
    def labels(self) -> pulumi.Output[Mapping[str, str]]:
        """
        A set of key/value label pairs to assign to the Kubernetes cluster.
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter(name="logGroupId")
    def log_group_id(self) -> pulumi.Output[str]:
        """
        Log group where cluster stores cluster system logs, like audit, events, or controlplane logs.
        """
        return pulumi.get(self, "log_group_id")

    @property
    @pulumi.getter
    def master(self) -> pulumi.Output['outputs.KubernetesClusterMaster']:
        """
        Kubernetes master configuration options. The structure is documented below.
        """
        return pulumi.get(self, "master")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of a specific Kubernetes cluster.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Output[str]:
        """
        The ID of the cluster network.
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter(name="networkImplementation")
    def network_implementation(self) -> pulumi.Output[Optional['outputs.KubernetesClusterNetworkImplementation']]:
        """
        (Optional) Network Implementation options. The structure is documented below.
        ---
        """
        return pulumi.get(self, "network_implementation")

    @property
    @pulumi.getter(name="networkPolicyProvider")
    def network_policy_provider(self) -> pulumi.Output[Optional[str]]:
        """
        Network policy provider for the cluster. Possible values: `CALICO`.
        """
        return pulumi.get(self, "network_policy_provider")

    @property
    @pulumi.getter(name="nodeIpv4CidrMaskSize")
    def node_ipv4_cidr_mask_size(self) -> pulumi.Output[Optional[int]]:
        """
        Size of the masks that are assigned to each node in the cluster. Effectively limits maximum number of pods for each node.
        """
        return pulumi.get(self, "node_ipv4_cidr_mask_size")

    @property
    @pulumi.getter(name="nodeServiceAccountId")
    def node_service_account_id(self) -> pulumi.Output[str]:
        """
        Service account to be used by the worker nodes of the Kubernetes cluster
        to access Container Registry or to push node logs and metrics.
        """
        return pulumi.get(self, "node_service_account_id")

    @property
    @pulumi.getter(name="releaseChannel")
    def release_channel(self) -> pulumi.Output[str]:
        """
        Cluster release channel.
        """
        return pulumi.get(self, "release_channel")

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> pulumi.Output[str]:
        """
        Service account to be used for provisioning Compute Cloud and VPC resources
        for Kubernetes cluster. Selected service account should have `edit` role on the folder where the Kubernetes
        cluster will be located and on the folder where selected network resides.
        """
        return pulumi.get(self, "service_account_id")

    @property
    @pulumi.getter(name="serviceIpv4Range")
    def service_ipv4_range(self) -> pulumi.Output[str]:
        """
        CIDR block. IP range Kubernetes service Kubernetes cluster
        IP addresses will be allocated from. It should not overlap with any subnet in the network
        the Kubernetes cluster located in.
        """
        return pulumi.get(self, "service_ipv4_range")

    @property
    @pulumi.getter(name="serviceIpv6Range")
    def service_ipv6_range(self) -> pulumi.Output[str]:
        """
        Identical to service_ipv4_range but for IPv6 protocol.
        """
        return pulumi.get(self, "service_ipv6_range")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        (Computed)Status of the Kubernetes cluster.
        """
        return pulumi.get(self, "status")

