# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['OrganizationManagerOrganizationIamMemberArgs', 'OrganizationManagerOrganizationIamMember']

@pulumi.input_type
class OrganizationManagerOrganizationIamMemberArgs:
    def __init__(__self__, *,
                 member: pulumi.Input[str],
                 organization_id: pulumi.Input[str],
                 role: pulumi.Input[str],
                 sleep_after: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a OrganizationManagerOrganizationIamMember resource.
        :param pulumi.Input[str] member: The identity that will be granted the privilege that is specified in the `role` field.
               This field can have one of the following values:
               * **userAccount:{user_id}**: A unique user ID that represents a specific Yandex account.
               * **serviceAccount:{service_account_id}**: A unique service account ID.
               * **federatedUser:{federated_user_id}**: A unique federated user ID.
        :param pulumi.Input[str] organization_id: ID of the organization to attach a policy to.
        :param pulumi.Input[str] role: The role that should be assigned.
        """
        pulumi.set(__self__, "member", member)
        pulumi.set(__self__, "organization_id", organization_id)
        pulumi.set(__self__, "role", role)
        if sleep_after is not None:
            pulumi.set(__self__, "sleep_after", sleep_after)

    @property
    @pulumi.getter
    def member(self) -> pulumi.Input[str]:
        """
        The identity that will be granted the privilege that is specified in the `role` field.
        This field can have one of the following values:
        * **userAccount:{user_id}**: A unique user ID that represents a specific Yandex account.
        * **serviceAccount:{service_account_id}**: A unique service account ID.
        * **federatedUser:{federated_user_id}**: A unique federated user ID.
        """
        return pulumi.get(self, "member")

    @member.setter
    def member(self, value: pulumi.Input[str]):
        pulumi.set(self, "member", value)

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> pulumi.Input[str]:
        """
        ID of the organization to attach a policy to.
        """
        return pulumi.get(self, "organization_id")

    @organization_id.setter
    def organization_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "organization_id", value)

    @property
    @pulumi.getter
    def role(self) -> pulumi.Input[str]:
        """
        The role that should be assigned.
        """
        return pulumi.get(self, "role")

    @role.setter
    def role(self, value: pulumi.Input[str]):
        pulumi.set(self, "role", value)

    @property
    @pulumi.getter(name="sleepAfter")
    def sleep_after(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "sleep_after")

    @sleep_after.setter
    def sleep_after(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "sleep_after", value)


@pulumi.input_type
class _OrganizationManagerOrganizationIamMemberState:
    def __init__(__self__, *,
                 member: Optional[pulumi.Input[str]] = None,
                 organization_id: Optional[pulumi.Input[str]] = None,
                 role: Optional[pulumi.Input[str]] = None,
                 sleep_after: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering OrganizationManagerOrganizationIamMember resources.
        :param pulumi.Input[str] member: The identity that will be granted the privilege that is specified in the `role` field.
               This field can have one of the following values:
               * **userAccount:{user_id}**: A unique user ID that represents a specific Yandex account.
               * **serviceAccount:{service_account_id}**: A unique service account ID.
               * **federatedUser:{federated_user_id}**: A unique federated user ID.
        :param pulumi.Input[str] organization_id: ID of the organization to attach a policy to.
        :param pulumi.Input[str] role: The role that should be assigned.
        """
        if member is not None:
            pulumi.set(__self__, "member", member)
        if organization_id is not None:
            pulumi.set(__self__, "organization_id", organization_id)
        if role is not None:
            pulumi.set(__self__, "role", role)
        if sleep_after is not None:
            pulumi.set(__self__, "sleep_after", sleep_after)

    @property
    @pulumi.getter
    def member(self) -> Optional[pulumi.Input[str]]:
        """
        The identity that will be granted the privilege that is specified in the `role` field.
        This field can have one of the following values:
        * **userAccount:{user_id}**: A unique user ID that represents a specific Yandex account.
        * **serviceAccount:{service_account_id}**: A unique service account ID.
        * **federatedUser:{federated_user_id}**: A unique federated user ID.
        """
        return pulumi.get(self, "member")

    @member.setter
    def member(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "member", value)

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the organization to attach a policy to.
        """
        return pulumi.get(self, "organization_id")

    @organization_id.setter
    def organization_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "organization_id", value)

    @property
    @pulumi.getter
    def role(self) -> Optional[pulumi.Input[str]]:
        """
        The role that should be assigned.
        """
        return pulumi.get(self, "role")

    @role.setter
    def role(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "role", value)

    @property
    @pulumi.getter(name="sleepAfter")
    def sleep_after(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "sleep_after")

    @sleep_after.setter
    def sleep_after(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "sleep_after", value)


class OrganizationManagerOrganizationIamMember(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 member: Optional[pulumi.Input[str]] = None,
                 organization_id: Optional[pulumi.Input[str]] = None,
                 role: Optional[pulumi.Input[str]] = None,
                 sleep_after: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Allows creation and management of a single member for a single binding within
        the IAM policy for an existing Yandex Organization Manager organization.

        > **Note:** Roles controlled by `OrganizationManagerOrganizationIamBinding`
           should not be assigned using `OrganizationManagerOrganizationIamMember`.

        > **Note:** When you delete `OrganizationManagerOrganizationIamBinding` resource,
           the roles can be deleted from other users within the organization as well. Be careful!

        ## Example Usage

        ```python
        import pulumi
        import pulumi_yandex as yandex

        editor = yandex.OrganizationManagerOrganizationIamMember("editor",
            member="userAccount:user_id",
            organization_id="some_organization_id",
            role="editor")
        ```

        ## Import

        IAM member imports use space-delimited identifiers; the resource in question, the role, and the account. This member resource can be imported using the `organization id`, role, and account, e.g.

        ```sh
         $ pulumi import yandex:index/organizationManagerOrganizationIamMember:OrganizationManagerOrganizationIamMember my_project "organization_id viewer foo@example.com"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] member: The identity that will be granted the privilege that is specified in the `role` field.
               This field can have one of the following values:
               * **userAccount:{user_id}**: A unique user ID that represents a specific Yandex account.
               * **serviceAccount:{service_account_id}**: A unique service account ID.
               * **federatedUser:{federated_user_id}**: A unique federated user ID.
        :param pulumi.Input[str] organization_id: ID of the organization to attach a policy to.
        :param pulumi.Input[str] role: The role that should be assigned.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: OrganizationManagerOrganizationIamMemberArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Allows creation and management of a single member for a single binding within
        the IAM policy for an existing Yandex Organization Manager organization.

        > **Note:** Roles controlled by `OrganizationManagerOrganizationIamBinding`
           should not be assigned using `OrganizationManagerOrganizationIamMember`.

        > **Note:** When you delete `OrganizationManagerOrganizationIamBinding` resource,
           the roles can be deleted from other users within the organization as well. Be careful!

        ## Example Usage

        ```python
        import pulumi
        import pulumi_yandex as yandex

        editor = yandex.OrganizationManagerOrganizationIamMember("editor",
            member="userAccount:user_id",
            organization_id="some_organization_id",
            role="editor")
        ```

        ## Import

        IAM member imports use space-delimited identifiers; the resource in question, the role, and the account. This member resource can be imported using the `organization id`, role, and account, e.g.

        ```sh
         $ pulumi import yandex:index/organizationManagerOrganizationIamMember:OrganizationManagerOrganizationIamMember my_project "organization_id viewer foo@example.com"
        ```

        :param str resource_name: The name of the resource.
        :param OrganizationManagerOrganizationIamMemberArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(OrganizationManagerOrganizationIamMemberArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 member: Optional[pulumi.Input[str]] = None,
                 organization_id: Optional[pulumi.Input[str]] = None,
                 role: Optional[pulumi.Input[str]] = None,
                 sleep_after: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = OrganizationManagerOrganizationIamMemberArgs.__new__(OrganizationManagerOrganizationIamMemberArgs)

            if member is None and not opts.urn:
                raise TypeError("Missing required property 'member'")
            __props__.__dict__["member"] = member
            if organization_id is None and not opts.urn:
                raise TypeError("Missing required property 'organization_id'")
            __props__.__dict__["organization_id"] = organization_id
            if role is None and not opts.urn:
                raise TypeError("Missing required property 'role'")
            __props__.__dict__["role"] = role
            __props__.__dict__["sleep_after"] = sleep_after
        super(OrganizationManagerOrganizationIamMember, __self__).__init__(
            'yandex:index/organizationManagerOrganizationIamMember:OrganizationManagerOrganizationIamMember',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            member: Optional[pulumi.Input[str]] = None,
            organization_id: Optional[pulumi.Input[str]] = None,
            role: Optional[pulumi.Input[str]] = None,
            sleep_after: Optional[pulumi.Input[int]] = None) -> 'OrganizationManagerOrganizationIamMember':
        """
        Get an existing OrganizationManagerOrganizationIamMember resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] member: The identity that will be granted the privilege that is specified in the `role` field.
               This field can have one of the following values:
               * **userAccount:{user_id}**: A unique user ID that represents a specific Yandex account.
               * **serviceAccount:{service_account_id}**: A unique service account ID.
               * **federatedUser:{federated_user_id}**: A unique federated user ID.
        :param pulumi.Input[str] organization_id: ID of the organization to attach a policy to.
        :param pulumi.Input[str] role: The role that should be assigned.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _OrganizationManagerOrganizationIamMemberState.__new__(_OrganizationManagerOrganizationIamMemberState)

        __props__.__dict__["member"] = member
        __props__.__dict__["organization_id"] = organization_id
        __props__.__dict__["role"] = role
        __props__.__dict__["sleep_after"] = sleep_after
        return OrganizationManagerOrganizationIamMember(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def member(self) -> pulumi.Output[str]:
        """
        The identity that will be granted the privilege that is specified in the `role` field.
        This field can have one of the following values:
        * **userAccount:{user_id}**: A unique user ID that represents a specific Yandex account.
        * **serviceAccount:{service_account_id}**: A unique service account ID.
        * **federatedUser:{federated_user_id}**: A unique federated user ID.
        """
        return pulumi.get(self, "member")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> pulumi.Output[str]:
        """
        ID of the organization to attach a policy to.
        """
        return pulumi.get(self, "organization_id")

    @property
    @pulumi.getter
    def role(self) -> pulumi.Output[str]:
        """
        The role that should be assigned.
        """
        return pulumi.get(self, "role")

    @property
    @pulumi.getter(name="sleepAfter")
    def sleep_after(self) -> pulumi.Output[Optional[int]]:
        return pulumi.get(self, "sleep_after")

